<?

/*
 * php-booba - simple PHP web application network
 * Copyright (C) 2004  Marcin Gajda
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

class Init
{
	function get()
	{
		require_once( PHP_BOOBA_ROOT.'include/db.phpi' );
		require_once( PHP_BOOBA_ROOT.'include/ticket.phpi' );
		require_once( PHP_BOOBA_ROOT.'include/verifier.phpi' );
		require_once( PHP_BOOBA_ROOT.'include/error.phpi' );

		$db = getDB();
		$ticket = getTicketService();

		/*
		 * Sprawdzenie dania.
		 */
		$request = $ticket->findTicket( verifyFromREQUEST( VER_TICKET , 'tid' , 'main' ) );

		/*
		 * Wyczyszczenie ticketw.
		 */
		$ticket->clear();

		/*
		 * Pobranie odpowiedniej klasy do renderowania strony.
		 */
		$page = $this->getPageForRender( $request , $_REQUEST );

		/*
		 * Przetworzenie dania.
		 */
		$result = $page->render( $request , $_REQUEST );
		
		/*
		 * Zapamitanie ticketw.
		 */
		$ticket->saveTickets();

		/*
		 * Zwrcenie wyniku.
		 */
		return $result;
	}

	function getPageForRender( $request , $additionalParameters )
	{
		$className = verifyFromArray( VER_NOT_ZERO_LENGTH_STRING , $request , 'page' , 'main' );

		/*
		 * Zacignicie pliku odpowiedniej klasy.
		 */
		require_once( PHP_BOOBA_ROOT.'include/pages/'.$className.'/'.$className.'.inc.php' );

		/*
		 * Klasy stron maj przyrostek 'Page' i rozpoczynaj si wielk liter.
		 */
		$className = ucfirst( $className ).'Page';

		$page = new $className();

		return $page;
	}
}

?>
